class
	CE_EXCEPTION

inherit
	DEVELOPER_EXCEPTION
		rename
			raise as re_raise
		end

create
	default_create, -- dummy; CE_STATIC initialization
	make

feature {NONE}

	make (a_routine: POINTER; a_position: INTEGER_32; a_value_var: POINTER)
		do
			routine := a_routine
			position := a_position
			value_var := a_value_var
			{CE_INTEGER_32_POINTER}.c_write (a_value_var, 0, 0)
		end

feature {ANY}

	routine: POINTER

	position: INTEGER_32

	raise (a_value: INTEGER_32)
		do
			if a_value = 0 then
				{CE_INTEGER_32_POINTER}.c_write (value_var, 0, 1)
			else
				{CE_INTEGER_32_POINTER}.c_write (value_var, 0, a_value)
			end
			re_raise
		end

feature {NONE}

	value_var: POINTER

end
