class
	CE_CLASS_ARRAY [G -> CE_CLASS]

inherit
	CE_ARRAY [G]
		redefine
			make,
			make_shared,
			make_shared_from_pointer
		end
	CE_CLASS_POINTER [G]
		rename
			make as make_from_pointer,
			make_shared as make_shared_from_pointer,
			make_shared_with_count as make_shared_with_count_from_pointer,
			make_cast as make_cast_from_pointer
		undefine
			make_from_pointer,
			make_shared_from_pointer,
			make_shared_with_count_from_pointer,
			make_cast_from_pointer,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_shared_from_pointer,
	make_initialized

feature {NONE}

	make (a_dimensions: ARRAY [INTEGER_32])
		do
			init_element_info
			Precursor (a_dimensions)
		end

	make_shared (a_c_pointer: POINTER; a_dimensions: ARRAY [INTEGER_32])
		do
			init_element_info
			Precursor (a_c_pointer, a_dimensions)
		end

	make_shared_from_pointer (a_c_pointer: POINTER)
		do
			init_element_info
			Precursor {CE_ARRAY} (a_c_pointer)
		end

end
