class
	CE_VA_LIST_POINTER

inherit
	CE_POINTER [CE_VA_LIST]

create
	make,
	make_shared,
	make_shared_with_count,
	make_cast

feature {ANY}

	element_size: INTEGER_32
		do
			Result := {PLATFORM}.Pointer_bytes
		end

feature {ANY}

	i_th alias "[]" (a_index: INTEGER_32): CE_VA_LIST assign set_i_th
		do
			create Result.make_shared_indirect (c_pointer + (a_index * element_size))
		end

	set_i_th (a_item: CE_VA_LIST; a_index: INTEGER_32)
		do
			{CE_POINTER_POINTER [ANY]}.c_write (c_pointer, a_index * {PLATFORM}.Pointer_bytes, a_item.c_pointer)
		end

feature {ANY}

	plus alias "+" (i: INTEGER_32): CE_VA_LIST_POINTER
		do
			if byte_count = {INTEGER_32}.Max_value then
				create Result.make_shared (c_pointer + (i * {PLATFORM}.Pointer_bytes))
			else
				create Result.make_shared_with_count (c_pointer + (i * {PLATFORM}.Pointer_bytes), count - i)
			end
		end

end
