class
	CE_VOID_POINTER

inherit
	CE_POINTER [ANY]

create
	make,
	make_shared,
	make_shared_with_count,
	make_cast

feature {ANY}

	element_size: INTEGER_32 = 1

feature {ANY}

	i_th alias "[]" (a_index: INTEGER_32): ANY assign set_i_th
		do
			check False then
				-- Void pointers can't be dereferenced.
			end
		end

	set_i_th (a_item: ANY; a_index: INTEGER_32)
		do
			check False then
				-- Void pointers can't be dereferenced.
			end
		end

feature {ANY}

	plus alias "+" (i: INTEGER_32): CE_VOID_POINTER
		do
			if byte_count = {INTEGER_32}.Max_value then
				create Result.make_shared (c_pointer + i)
			else
				create Result.make_shared_with_count (c_pointer + i, count - i)
			end
		end

end
