frozen expanded class
	CE_ALLOCA_FACTORY

inherit
	ANY
		redefine
			default_create
		end

create
	default_create

feature {NONE}

	default_create
		do
			create allocated.make
		end

	allocated: TWO_WAY_LIST [MANAGED_POINTER]

feature {ANY}

	new (a_count: NATURAL_32): CE_POINTER [ANY]
		local
			l_p: MANAGED_POINTER
		do
			create l_p.make (a_count.to_integer_32)
			allocated.extend (l_p)
			create {CE_VOID_POINTER} Result.make_shared_with_count (l_p.item, l_p.count)
		end

end
